/* sorgente: Strncat.c */

/* illustra le modalit di utilizzo della funzione strncat()*/

/* inclusione del file di intestazione della libreria standard che
** contiene definizioni di macro, costanti e dichiarazioni di funzioni
** e tipi di interesse generale, funzionali alle varie operazioni di I/O
** e alla gestione delle stringhe, rispettivamente */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/* definisce la lunghezza massima prevista per una stringa, '\0' escluso */
#define STR_LENGTH 80

/* chiamante */
int main ()
  {
  /* defisce le stringhe destinazione e sorgente e una variabile per il numero
  ** di caratteri da concatenare */
  char *Dst, *Src;
  unsigned int nro;
  
  /* alloca memoria per la stringa destinazione e la stringa
  ** sorgente. Se loperazione ha esito negativo, recupera la
  ** memoria eventualmente allocate e termina */
  Src = (char *) malloc((STR_LENGTH+1)*sizeof(char));
  
  if (Src == NULL)
		return(0);
	
  Dst = (char *) malloc((STR_LENGTH+1)*sizeof(char));

  if (Dst == NULL)
		{
		free(Src);
		return(0);
		};

  /* acquisisce il contenuto delle due stringhe */
  printf("\nDestinazione? ");
  scanf("%s", Dst);

  printf("\nSorgente? ");
  scanf("%s", Src);

  /* acquisisce il numero di caratteri da concatenare */
  printf("\nNumero di caratteri? ");
  scanf("%u", &nro);
  
  /* concatena nro caratteri della stringa sorgente alla destinazione e
  ** visualizza il risultato delloperazione */
  printf("\nDestinazione: %s\n", strncat(Dst, Src, nro));

  /* rilascia la memoria allocata per le stringhe */
  free(Src); 
  free(Dst);
	
  return(1);
}
